import java.util.Arrays;

/*
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
Verwenden Sie die gegebenen Testklassen zum Überprüfen Ihrer Lösung. Die Korrektheit dieser Testfälle
ist notwendig, aber nicht hinreichend für eine korrekte Lösung.
*/
public class Aufgabe1 {

    /*
    Aufgabe: Manipulation von einfachen Arrays.

        Ergänzen Sie fehlende Teile dieser Klasse entsprechend den Kommentaren
        an den mit TODO gekennzeichneten Stellen.
        Sonstige Anforderungen: Die Verwendung der Klasse 'String' oder 'StringBuffer'
        ist nicht erlaubt. Es sollen keine zusätzlichen Methoden implementiert werden.
        Hinweis: Die beiden gefragten Methoden funktionieren ähnlich. Sie dürfen sich
        daher gegenseitig aufrufen, oder auch unabhängig implementiert werden.

    Punkte (maximal 20):
        10 Punkte für die Implementierung von 'insert',
        10 Punkte für die Implementierung von 'insertMutating'.
    */


    // Liefert ein neues Array zurück, mit dem Inhalt aus 'array',
    // in dem jedoch ab der Stelle 'pos' in 'array'
    // die Einträge aus 'insert' eingefügt wurden.
    // Alle Einträge nach 'pos' verschieben sich um insert.length Positionen
    // in Richtung größerem Index, um für die neuen Einträge Platz zu machen.
    // Das zurückgelieferte Array hat daher die Größe array.length+insert.length.
    // Die originalen Arrays 'array' und 'insert' bleiben unverändert.
    // Beachten Sie die Beispiele in der Methode 'main' (siehe unten).
    // Vorbedingung: array != null und array.length > 0 und
    // insert != null und pos ist ein gültiger Index.
    public static int[] insert(int[] array, int[] insert, int pos) {
        // TODO: implementieren Sie die Methode.

            int[] result = new int[array.length + insert.length];

            int j = 0;
            for (int i = 0; i < result.length; i++) {
                if (i >= pos && j < insert.length) {
                    result[i] = insert[j];
                    j++;
                } else {
                    result[i] = array[i - j];
                }
                }
            return result;




             //TODO: Diese Zeile löschen oder entsprechend verändern.
        }


    // Fügt ab der Stelle 'pos' in 'array' die Einträge aus 'insert' ein.
    // Alle Einträge nach 'pos' verschieben sich um insert.length Positionen
    // in Richtung größerem Index, um für die neuen Einträge Platz zu machen.
    // Die letzten insert.length Einträge mit größten Indizes gehen
    // durch die Verschiebung verloren.
    // Beachten Sie die Beispiele in der Methode 'main' (siehe unten).
    // Vorbedingung: array != null und array.length > 0 und
    // insert != null und pos ist ein gültiger Index.
    public static void insertMutating(int[] array, int[] insert, int pos) {

        int[] result = new int[array.length];

        int j = 0;
        for (int i = 0; i < array.length; i++) {
            if (i >= pos && j < insert.length) {
                result[i] = insert[j];
                j++;
            } else {
                result[i] = array[i-j];
            }

        }


        for (int i = 0; i < array.length; i++) {
            array[i] = result[i];
        }

        // TODO: implementieren Sie die Methode.
    }

    // Diese Methode können Sie zum Testen nutzen. Sie geht nicht in die Beurteilung ein.
    public static void main(String[] args) {

        //Testen von insert:
        int[] array = new int[]{15,12,10,14,17};
        int[] toInsert = new int[]{2,3};
        System.out.println(Arrays.toString(insert(array,toInsert,2))); //[15, 12, 2, 3, 10, 14, 17]

        //Testen von insertMutating:
        array = new int[]{15,12,10,14,17};
        toInsert = new int[]{2,3};
        insertMutating(array,toInsert,2);
        System.out.println(Arrays.toString(array)); //[15, 12, 2, 3, 10]

    }
}

