import java.util.Arrays;

public class Aufgabe3 {

    /*
    Aufgabe:
        Rekursive Methoden.
        Verändern Sie die Implementierungen der Methoden dieser Klasse entsprechend
        den Kommentaren an den mit TODO gekennzeichneten Stellen.

        Die Methoden sollen Ihr Ein-/Ausgabeverhalten auf gültigen Eingaben behalten.

        Der Programmcode soll OHNE SCHLEIFEN und OHNE GLOBALE VARIABLEN
        (Variablen, die außerhalb eines Methodenrumpfs deklariert werden) auskommen!

        Die gegebenen Methodenköpfe sollen nicht verändert werden.
        Zusätzliche Hilfsmethoden sind nicht erlaubt. Die Verwendung von Methoden aus
        java.util.Arrays ist erlaubt.

    Punkte (maximal 20):
        8 Punkte für die Implementierung von 'palindrom',
        6 Punkte für die Implementierung von 'f',
        6 Punkte für die Implementierung von 'printDigits',
    */

    // Liefert 'true', wenn die von 'array' dargestellte Zeichenkette
    // vorwärts und rückwärts gelesen die gleiche ist.
    // Vorbedingung: array != null
    public static boolean palindrom(char[] array) {
        //TODO: Ersetzen Sie die Schleife durch Rekursion.

        if (array.length > 1) {
            if (array[0] != array[array.length - 1]) {
                return false;
            } else {
                return palindrom(Arrays.copyOfRange(array, 1, array.length - 1));
            }
        } else {
            return true;
        }
      //  while(array.length > 1) {
      //      if (array[0] != array[array.length-1]) {
      //          return false;
      //      }
      //      array = Arrays.copyOfRange(array, 1, array.length-1);
      //  }
      //  return true;

    }

    // Vorbedingung: k != 0
    public static int f(int n, int k) {
        //TODO: Entfernen Sie die Rekursion (ersetzen Sie durch Schleife oder Operator).

        if (n < 0) {
            return (-2 * n) / (2 * k);
        } else {
            return n/(2*k);
        }
        //return n < 0 ? f(-2*n,k) : n/(2*k);

    }

    // Gibt alle Ziffern von n in umgekehrter Reihenfolge aus.
    // Die Ausgabe wird mit einem '.' abgeschlossen.
    // Vorbedingung: n >= 0.
    public static void printDigits(int n) {
        //TODO: Ersetzen Sie die Schleife durch Rekursion.

        if (n > 0) {
            System.out.print(n % 10);

            printDigits(n / 10);
        } else {
            System.out.println(".");
        }
     //   do {
     //       System.out.print(n % 10);
     //       n /= 10;
     //   } while (n > 0);
     //   System.out.println(".");

    }

    // Diese Methode können Sie zum Testen nutzen. Geht nicht in die Beurteilung ein.
    public static void main(String[] args) {

        System.out.println(Aufgabe3.palindrom(new char[] {'P','K'})); // false
        System.out.println(Aufgabe3.palindrom(new char[] {'A','N','N','A'})); // true
        System.out.println(Aufgabe3.palindrom(new char[] {'E','H','E'})); // true
        System.out.println(Aufgabe3.palindrom(new char[] {'G','E','H','E','N'})); // false

        System.out.println(f(-10, 5));
        System.out.println(f(10, 5));


        printDigits(0); //321.
        printDigits(15); //51.
        printDigits(20); //02.
        printDigits(63); //36.

    }

}

